﻿Imports System.Collections.Generic

Public Class Form1
    Private Panels As New List(Of Panel)()
    Private VisiblePanel As Panel = Nothing

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Load saved values.
        RegistryTools.LoadAllSettings(Application.ProductName, Me)

        ' Expand all tree nodes.
        treeView1.ExpandAll()

        ' Move the Panels out of the TabControl.
        tabControl1.Visible = False
        For Each page As TabPage In tabControl1.TabPages
            ' Add the Panel to the list.
            Dim the_panel As Panel = DirectCast(page.Controls(0), Panel)
            Panels.Add(the_panel)

            ' Reparent and move the Panel.
            the_panel.Parent = tabControl1.Parent
            the_panel.Location = tabControl1.Location
            the_panel.Visible = False
        Next page

        ' Display the first panel.
        DisplayPanel(0)
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        RegistryTools.SaveAllSettings(Application.ProductName, Me)
    End Sub

    Private Sub vScrollBar1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles vScrollBar1.ValueChanged
        lblVbar1.Text = vScrollBar1.Value.ToString()
    End Sub
    Private Sub vScrollBar2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles vScrollBar2.ValueChanged
        lblVbar2.Text = vScrollBar2.Value.ToString()
    End Sub
    Private Sub vScrollBar3_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles vScrollBar3.ValueChanged
        lblVbar3.Text = vScrollBar3.Value.ToString()
    End Sub

    ' Display the appropriate Panel.
    Private Sub treeView1_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles treeView1.AfterSelect
        Dim index As Integer = Integer.Parse(e.Node.Tag.ToString())
        DisplayPanel(index)
    End Sub

    ' Display the appropriate Panel.
    Private Sub DisplayPanel(ByVal index As Integer)
        If (Panels.Count < 1) Then Return

        ' If this is the same Panel, do nothing.
        If (VisiblePanel Is Panels(index)) Then Return

        ' Hide the previously visible Panel.
        If (VisiblePanel IsNot Nothing) Then VisiblePanel.Visible = False

        ' Display the appropriate Panel.
        Panels(index).Visible = True
        VisiblePanel = Panels(index)
    End Sub
End Class
